#include "resrc1.h"
#include "MATH.H"

LRESULT CALLBACK StartParamDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam);
void StartParam2Dlg();
void StartDlg2Param();
void StartGetHandles();
HWND StartParamHWND;
//HWND L_hwnd,M_hwnd,J_hwnd,X_hwnd,Y_hwnd;

double fGaus(double x);
double fImpuls(double x);
double fSin(double x);
double f4(double x);
double fTImpuls(double x);
double fRandom(double x);


typedef double (*PFN)(double);
typedef struct
{
  WORD form_id;
  int  Ae,Be,Ce,De;
  char *Text;
  double  A,B,C,D;
  double  fi_0,fi_t_0;
  int Pnum;
  int GarmNum;
  char *Menu;
  PFN fn;
} FORM;

WORD form_num;
FORM Form[] =
{
    {50001, 1, 0, 0, 0, "y=exp(-Ax^2)",                             1, 0, 0, 0, -10, 10,     800, 15,  "",   fGaus},
    {50002, 1, 0, 0, 0, "A- ",                        30,0, 0, 0, -256,256,    512, 512, "", fImpuls},
    {50003, 1, 1, 0, 0, "y=Sin(A*x)*Sin(B*x)",                      3, 5, 0, 0, 0,   2*M_PI, 800, 10,  "",   fSin},
    {50004, 0, 0, 0, 0, "y=1/((1+x^2)^2)",                          0, 0, 0, 0, -10, 10,     800, 20,  "y=1/((1+x^2)^2)",   f4},
    {50005, 1, 0, 0, 0, "A- ",                        30,0, 0, 0, -256,256,    512, 512, " ", fTImpuls},
    {50006, 1, 1, 0, 0, "A-     B- ",5, 5, 0, 0, 0,   800,    800, 800, " ",    fRandom},
    {50007, 0, 0, 0, 0, "",                                     0, 0, 0, 0, 0,   0,      0,   100, "",    NULL}
};
int MaxForm=sizeof(Form) / sizeof(FORM);

#pragma argsused
LRESULT CALLBACK StartParamDlgProc(HWND hdlg,UINT uMessage,WPARAM wparam,LPARAM lparam)
{
  WORD Command;

  switch (uMessage)
  {
    case WM_INITDIALOG:
      StartParamHWND=hdlg;
      StartGetHandles();
      StartParam2Dlg();
      break;
    case WM_COMMAND:
      Command=LOWORD(wparam);
      if(Command==IDOK)
      {
        StartDlg2Param();
        EndDialog(hdlg, TRUE);
      }
      if(Command==IDCANCEL)
        EndDialog(hdlg, TRUE);
      break;
    default:
      return 0;
//      return DefDlgProc(hdlg, uMessage, wparam, lparam);
  }
  return 0;
}
void StartGetHandles()
{
//  L_hwnd=GetDlgItem(ParamHWND,IDC_EDIT_L);
}

void StartParam2Dlg()
{
  char szbuf[100];
  HANDLE fn;
  DWORD leng;
  SECURITY_ATTRIBUTES sa;
  OPENFILENAME ofn = {0};
  char szFile[256]="*.dat\0";       // filename string
  char szFilter[]="*.dat\0";     // filter string
  char szFileTitle[256]={0};  // file-title string
   FILE *inp,*out,*out1;
   char string[0x100];
   double  StartAngle=0,EndAngle=0,Angle,num;
   int fl,i;

sa.nLength = sizeof( sa );
sa.lpSecurityDescriptor = NULL;
sa.bInheritHandle = FALSE;

  if(Form[form_num].form_id==40007)
  {
    ofn.lStructSize = sizeof(OPENFILENAME);
    ofn.hwndOwner = StartParamHWND;
    ofn.lpstrFilter = szFilter;
    ofn.nFilterIndex = 1;
    ofn.lpstrFile = szFile;
    ofn.nMaxFile = sizeof(szFile);
    ofn.lpstrFileTitle = szFileTitle;
    ofn.nMaxFileTitle = sizeof(szFileTitle);
    ofn.lpstrInitialDir = NULL; //szDirName;
    ofn.Flags = OFN_SHOWHELP | OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;

    // Display the Open dialog box.

    if (GetOpenFileName(&ofn))
    {
      inp = fopen(szFileTitle, "rb");
    }

  }
  else
  {
  }


  SetDlgItemText(StartParamHWND, IDC_FORM, Form[form_num].Text);

  EnableWindow(GetDlgItem(StartParamHWND,IDC_EDIT_A),Form[form_num].Ae);
  EnableWindow(GetDlgItem(StartParamHWND,IDC_EDIT_B),Form[form_num].Be);
  EnableWindow(GetDlgItem(StartParamHWND,IDC_EDIT_C),Form[form_num].Ce);
  EnableWindow(GetDlgItem(StartParamHWND,IDC_EDIT_D),Form[form_num].De);

  sprintf(szbuf,"%.18lf",Form[form_num].A);
  ZerroTruncate(szbuf);
  SetDlgItemText(StartParamHWND,IDC_EDIT_A,szbuf);
  sprintf(szbuf,"%.18lf",Form[form_num].B);
  ZerroTruncate(szbuf);
  SetDlgItemText(StartParamHWND,IDC_EDIT_B,szbuf);
  sprintf(szbuf,"%.18lf",Form[form_num].C);
  ZerroTruncate(szbuf);
  SetDlgItemText(StartParamHWND,IDC_EDIT_C,szbuf);
  sprintf(szbuf,"%.18lf",Form[form_num].D);
  ZerroTruncate(szbuf);
  SetDlgItemText(StartParamHWND,IDC_EDIT_D,szbuf);

  sprintf(szbuf,"%.18lf",Form[form_num].fi_0);
  ZerroTruncate(szbuf);
  SetDlgItemText(StartParamHWND,IDC_EDIT_FI,szbuf);
  sprintf(szbuf,"%.18lf",Form[form_num].fi_t_0);
  ZerroTruncate(szbuf);
  SetDlgItemText(StartParamHWND,IDC_EDIT_FI_T,szbuf);

  SetDlgItemInt(StartParamHWND,IDC_EDIT_PNUM,Form[form_num].Pnum,FALSE);
  SetDlgItemInt(StartParamHWND,IDC_EDIT_GARM_NUM,Form[form_num].GarmNum,FALSE);
}

void StartDlg2Param()
{
}









double fGaus(double x)
{
  return exp((-1)*Form[form_num].A*x*x);
}

double fImpuls(double x)
{
  if(abs(x)<Form[form_num].A/2)
    return 1;
  else
    return 0;
}

double fSin(double x)
{
  return sin(Form[form_num].A*x)*sin(Form[form_num].B*x);
}

double f4(double x)
{
  return 1/((1+x*x)*(1+x*x));
}

double fTImpuls(double x)
{
  if(abs(x)<Form[form_num].A/2)
    return (Form[form_num].A/2-abs(x))/(Form[form_num].A/2);
  else
    return 0;
}

#pragma argsused
double fRandom(double x)
{
    return ((double)random(0x7fffffff))/0x7fffffff;
}
